unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,linux, LResources, Forms, Controls, Graphics, Dialogs,process,
  StdCtrls,inifiles, Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);

  private
    function einlesen: tstringlist;
    function desktopenvironment (var ps:tstringlist):string;
    function windowmanager (var ps:tstringlist):string;
    function readkde :tstringlist;
    function readgnome:tstringlist;
    function kern:string;
    function kdeversion:string;
            { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 
  prozesse:tstringlist;
implementation

{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
var t,z:integer;
    back:string;

begin
 prozesse:=tstringlist.Create;
 prozesse:=einlesen;
 label1.Caption:='Desktop Environment '+form1.desktopenvironment(prozesse);
 label2.Caption:='Windowmanager '+form1.windowmanager(prozesse);
 label6.Caption:='Kernel '+kern;
 if  form1.desktopenvironment(prozesse)='KDE' then
 begin
 label3.caption:='Icons '+readkde[0];
 label5.caption:= 'Style '+readkde[2];
 back:=readkde[1];
 trim(back);
 t:=ansipos(',',back);
 delete(back,t,length(back));
 label4.caption:='Font '+back;
 label7.Caption:='Version '+kdeversion;
   end;
 if form1.desktopenvironment(prozesse)='Gnome' then
 begin
 label5.Caption:='Theme '+readgnome[0];
 label3.Caption:='Icon '+readgnome[1];
 label4.Caption:='Font '+readgnome[2];
 end;


end;

procedure TForm1.Label2Click(Sender: TObject);
begin

end;

procedure TForm1.Label3Click(Sender: TObject);
begin

end;



function TForm1.einlesen:tstringlist;
var t:tprocess;
    s:tstringlist;
begin
 t:=tprocess.create(nil);
 s:=tstringlist.Create;
 t.CommandLine:='ps -ux';
 t.Options:=[poUsePipes,poWaitonexit];
 t.Execute;
 s.LoadFromStream(t.OutPut);
 result:=s;
 t.Free;
end;

function TForm1.desktopenvironment(var ps: tstringlist):string;
var z:integer;
begin
 result:='unkown';
 for z := 0 to (ps.Count-1) do
 begin
 if ansipos('gnome-session',ps[z])>0 then result:='gnome';
 if ansipos('xfce-mcs-manage',ps[z])>0 then result:='XFCE';
 if ansipos('ksmserver',ps[z])>0 then result:='KDE';
 end;
end;

function TForm1.windowmanager(var ps: tstringlist): string;
var z:integer;
begin
 result:='unknown';
 for z:= 0 to (ps.Count-1) do
 begin
 if ansipos('beryl',ps[z])>0then result:='Beryl';
 if ansipos('fluxbox',ps[z])>0then result:='Fluxbox';
 if ansipos('openbox',ps[z])>0then result:='Openbox';
 if ansipos('blackbox',ps[z])>0then result:='Blackbox';
 if ansipos('xfwm4',ps[z])>0then result:='Xfwm4';
 if ansipos('metacity',ps[z])>0then result:='Metacity';
 if ansipos('kwin',ps[z])>0then result:='Kwin';
 if ansipos('fvwm',ps[z])>0then result:='FVWM';
 if ansipos('enlightenment',ps[z])>0then result:='Enlightenment';
 if ansipos('icewm',ps[z])>0then result:='Icewm';
 if ansipos('wmaker',ps[z])>0then result:='windowmaker';
 if ansipos('pekwm',ps[z])>0then result:='PekWm';
 end;
end;

function TForm1.readkde: tstringlist;
var config:tinifile;
    s:tstringlist;

begin
 config:=tinifile.Create(getenvironmentvariable('HOME')+'/.kde/share/config/kdeglobals');
 s:=tstringlist.Create;
 s.Add(config.ReadString('Icons','Theme',''));
 s.Add(config.ReadString('WM','activeFont',''));
 s.Add(config.ReadString('General','widgetstyle',''));
 result:=s;
end;

function TForm1.readgnome: tstringlist;
var gnom:tprocess;
    n,s:tstringlist;

begin
  gnom:=tprocess.Create(nil);
  s:=tstringlist.Create;
  n:=tstringlist.Create;
  gnom.Options:=[poUsePipes,poWaitonexit];
  gnom.CommandLine:='gconftool-2 -g /desktop/gnome/interface/gtk_theme';
  gnom.Execute;
  s.LoadFromStream(gnom.OutPut);
  n.Add(s[0]);
  gnom.CommandLine:='gconftool-2 -g /desktop/gnome/interface/icon_theme';
  gnom.Execute;
  s.LoadFromStream(gnom.OutPut);
  n.Add(s[0]);
  gnom.CommandLine:='gconftool-2 -g /desktop/gnome/interface/font_name';
  gnom.Execute;
  s.LoadFromStream(gnom.OutPut);
  n.Add(s[0]);
  result:=n ;
  gnom.Free;
end;

function TForm1.kern: string;
var
kernel:tprocess;
s:tstringlist;
begin
kernel:=tprocess.create(nil);
kernel.CommandLine:='uname -r';
s:=tstringlist.Create;
kernel.Options:=[pousepipes,powaitonexit];
kernel.Execute;
s.LoadFromstream(kernel.OutPut);
result:=s[0];
end;

function TForm1.kdeversion: string;
var
kvers:tprocess;
k:tstringlist;
begin
  k:=tstringlist.Create;
  kvers:=tprocess.create(nil);
  kvers.CommandLine:='kde-config --version';
  kvers.Options:=[pousepipes,powaitonexit];
  kvers.Execute;
  k.LoadFromstream(kvers.Output);
  result:=k[1];
end;


initialization
  {$I unit1.lrs}

end.

